Hierarchy (Apache Log4j 1.2.17 API)
Date: 2012-05-06

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.log4j
Class Hierarchy

    java.lang.Object
      org.apache.log4j.Hierarchy

All Implemented Interfaces:
  LoggerRepository, RendererSupport, ThrowableRendererSupport

    public class Hierarchy

extends Object
implements LoggerRepository, RendererSupport, ThrowableRendererSupport

This class is specialized in retrieving loggers by name and also maintaining the logger hierarchy.

The casual user does not have to deal with this class directly.

The structure of the logger hierarchy is maintained by the `getLogger(java.lang.String)` method. The hierarchy is such that children link to their parent but parents do not have any pointers to their children. Moreover, loggers can be instantiated in any order, in particular descendant before ancestor.

In case a descendant is created before a particular ancestor, then it creates a provision node for the ancestor and adds itself to the provision node. Other descendants of the same ancestor add themselves to the previously created provision node.

Author:
  Ceki Gülcü

Constructor Summary
`Hierarchy(Logger root)` Create a new logger hierarchy.

Method Summary
`void` | `addHierarchyEventListener(HierarchyEventListener listener)` Add a `HierarchyEventListener` event to the repository.
`void` | `addRenderer(Class classToRender, ObjectRenderer or)` Add an object renderer for a specific class.
`void` | `clear()` This call will clear all logger definitions from the internal hashtable.
`void` | `emitNoAppenderWarning(Category cat)`
`Logger` | `exists(String name)` Check if the named logger exists in the hierarchy.
`void` | `fireAddAppenderEvent(Category logger, Appender appender)`
`Enumeration` | `getCurrentCategories()` Deprecated. Please use `getCurrentLoggers()` instead.
`Enumeration` | `getCurrentLoggers()` Returns all the currently defined categories in this hierarchy as an `Enumeration`.
`Logger` | `getLogger(String name)` Return a new logger instance named as the first parameter using the default factory.
`Logger` | `getLogger(String name, LoggerFactory factory)` Return a new logger instance named as the first parameter using `factory`.
`RendererMap` | `getRendererMap()` Get the renderer map for this hierarchy.
`Logger` | `getRootLogger()` Get the root of this hierarchy.
`Level` | `getThreshold()` Returns a `Level` representation of the `enable` state.
`ThrowableRenderer` | `getThrowableRenderer()` Get throwable renderer.
`boolean` | `isDisabled(int level)` This method will return `true` if this repository is disabled for `level` object passed as parameter and `false` otherwise.
`void` | `overrideAsNeeded(String override)` Deprecated. Deprecated with no replacement.
`void` | `resetConfiguration()` Reset all values contained in this hierarchy instance to their default.
`void` | `setDisableOverride(String override)` Deprecated. Deprecated with no replacement.
`void` | `setRenderer(Class renderedClass, ObjectRenderer renderer)` Used by subclasses to add a renderer to the hierarchy passed as parameter.
`void` | `setThreshold(Level l)` Enable logging for logging requests with level `l` or higher.
`void` | `setThreshold(String levelStr)` The string form of `setThreshold(Level)`.
`void` | `setThrowableRenderer(ThrowableRenderer renderer)` Set throwable renderer.
`void` | `shutdown()` Shutting down a hierarchy will safely close and remove all appenders in all categories including the root logger.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Hierarchy

    public Hierarchy(Logger root)

  Create a new logger hierarchy.

  Parameters:
    `root` - The root of the new hierarchy.

Method Detail

### addRenderer

    public void addRenderer(Class classToRender,
                            ObjectRenderer or)

  Add an object renderer for a specific class.

### addHierarchyEventListener

    public void addHierarchyEventListener(HierarchyEventListener listener)

  Description copied from interface: `LoggerRepository`
  Add a `HierarchyEventListener` event to the repository.

  Specified by:
    `addHierarchyEventListener` in interface `LoggerRepository`

### clear

    public void clear()

  This call will clear all logger definitions from the internal hashtable. Invoking this method will irrevocably mess up the logger hierarchy.

  You should really know what you are doing before invoking this method.

  Since:
    0.9.0

### emitNoAppenderWarning

    public void emitNoAppenderWarning(Category cat)

  Specified by:
    `emitNoAppenderWarning` in interface `LoggerRepository`

### exists

    public Logger exists(String name)

  Check if the named logger exists in the hierarchy. If so return its reference, otherwise returns `null`.

  Specified by:
    `exists` in interface `LoggerRepository`
  Parameters:
    `name` - The name of the logger to search for.

### setThreshold

    public void setThreshold(String levelStr)

  The string form of `setThreshold(Level)`.

  Specified by:
    `setThreshold` in interface `LoggerRepository`

### setThreshold

    public void setThreshold(Level l)

  Enable logging for logging requests with level `l` or higher. By default all levels are enabled.

  Specified by:
    `setThreshold` in interface `LoggerRepository`
  Parameters:
    `l` - The minimum level for which logging requests are sent to their appenders.

### fireAddAppenderEvent

    public void fireAddAppenderEvent(Category logger,
                                     Appender appender)

  Specified by:
    `fireAddAppenderEvent` in interface `LoggerRepository`

### getThreshold

    public Level getThreshold()

  Returns a `Level` representation of the `enable` state.

  Specified by:
    `getThreshold` in interface `LoggerRepository`
  Since:
    1.2

### getLogger

    public Logger getLogger(String name)

  Return a new logger instance named as the first parameter using the default factory.

  If a logger of that name already exists, then it will be returned. Otherwise, a new logger will be instantiated and then linked with its existing ancestors as well as children.

  Specified by:
    `getLogger` in interface `LoggerRepository`
  Parameters:
    `name` - The name of the logger to retrieve.

### getLogger

    public Logger getLogger(String name,
                            LoggerFactory factory)

  Return a new logger instance named as the first parameter using `factory`.

  If a logger of that name already exists, then it will be returned. Otherwise, a new logger will be instantiated by the `factory` parameter and linked with its existing ancestors as well as children.

  Specified by:
    `getLogger` in interface `LoggerRepository`
  Parameters:
    `name` - The name of the logger to retrieve.
    `factory` - The factory that will make the new logger instance.

### getCurrentLoggers

    public Enumeration getCurrentLoggers()

  Returns all the currently defined categories in this hierarchy as an `Enumeration`.

  The root logger is not included in the returned `Enumeration`.

  Specified by:
    `getCurrentLoggers` in interface `LoggerRepository`

### getCurrentCategories

    public Enumeration getCurrentCategories()

  Deprecated. Please use `getCurrentLoggers()` instead.

  Description copied from interface: `LoggerRepository`
  Deprecated. Please use `LoggerRepository.getCurrentLoggers()` instead.

  Specified by:
    `getCurrentCategories` in interface `LoggerRepository`

### getRendererMap

    public RendererMap getRendererMap()

  Get the renderer map for this hierarchy.

  Specified by:
    `getRendererMap` in interface `RendererSupport`

### getRootLogger

    public Logger getRootLogger()

  Get the root of this hierarchy.

  Specified by:
    `getRootLogger` in interface `LoggerRepository`
  Since:
    0.9.0

### isDisabled

    public boolean isDisabled(int level)

  This method will return `true` if this repository is disabled for `level` object passed as parameter and `false` otherwise. See also the `threshold` emthod.

  Specified by:
    `isDisabled` in interface `LoggerRepository`

### overrideAsNeeded

    public void overrideAsNeeded(String override)

  Deprecated. Deprecated with no replacement.

### resetConfiguration

    public void resetConfiguration()

  Reset all values contained in this hierarchy instance to their default. This removes all appenders from all categories, sets the level of all non-root categories to `null`, sets their additivity flag to `true` and sets the level of the root logger to `DEBUG`. Moreover, message disabling is set its default "off" value.

  Existing categories are not removed. They are just reset.

  This method should be used sparingly and with care as it will block all logging until it is completed.

  Specified by:
    `resetConfiguration` in interface `LoggerRepository`
  Since:
    0.8.5

### setDisableOverride

    public void setDisableOverride(String override)

  Deprecated. Deprecated with no replacement.

  Does nothing.

### setRenderer

    public void setRenderer(Class renderedClass,
                            ObjectRenderer renderer)

  Used by subclasses to add a renderer to the hierarchy passed as parameter.

  Specified by:
    `setRenderer` in interface `RendererSupport`

### setThrowableRenderer

    public void setThrowableRenderer(ThrowableRenderer renderer)

  Set throwable renderer.

  Specified by:
    `setThrowableRenderer` in interface `ThrowableRendererSupport`
  Parameters:
    `renderer` - renderer, may be null.

### getThrowableRenderer

    public ThrowableRenderer getThrowableRenderer()

  Get throwable renderer.

  Specified by:
    `getThrowableRenderer` in interface `ThrowableRendererSupport`
  Returns:
    throwable renderer, may be null.

### shutdown

    public void shutdown()

  Shutting down a hierarchy will safely close and remove all appenders in all categories including the root logger.

  Some appenders such as `SocketAppender` and `AsyncAppender` need to be closed before the application exists. Otherwise, pending logging events might be lost.

  The `shutdown` method is careful to close nested appenders before closing regular appenders. This is allows configurations where a regular appender is attached to a logger and again to a nested appender.

  Specified by:
    `shutdown` in interface `LoggerRepository`
  Since:
    1.0

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2012 Apache Software Foundation. All Rights Reserved.